import com.imptt.proptt.pttserver.plugins.V2.*;
import java.sql.*;

public class PTTPlugin2Sample implements IPTTPlugin2
{
	ICallback2 cbObject = null;
	public int getInterfaceVersion()
	{
		System.out.println("PTTPlugin2Sample::getInterfaceVersion");
		return INTERFACE_VERSION;
	}
	
	public int getType()
	{
		System.out.println("PTTPlugin2Sample::getType");
		return TYPE_GENERAL_PLUGIN;
	}
	
	public void setCallback(ICallback2 cbObject)
	{
		System.out.println("PTTPlugin2Sample::setCallback cbObject="+cbObject);
		this.cbObject = cbObject;
	}
	
	public boolean initialize(String arg)
	{
		System.out.println("PTTPlugin2Sample::initialize arg="+arg);
		Connection conn = cbObject.getDBConnection();
		if(conn != null)
		{
			int dbSchemaVersion = 0;
			Statement stmt = null;
			try 
			{
				stmt = conn.createStatement();
				String sqlStr = "SELECT TextValue FROM TB_Setup WHERE TextKey='db.schema.version'";
				ResultSet rs = stmt.executeQuery(sqlStr);
				if(rs.next())
				{
					dbSchemaVersion = rs.getInt(1);
				}
			}
			catch (Exception e)
			{
				System.out.println(e.getMessage());
			}
			if ( stmt != null ) try { stmt.close(); }catch (Exception e){}
			System.out.println("PTTPlugin2Sample::initialize dbSchemaVersion="+dbSchemaVersion);
		}
		if(cbObject!=null) cbObject.OnInitialized();
		return true;
	}
	

	//events
	public void OnConnected(String userId, String jsonParams)
	{
		System.out.println("PTTPlugin2Sample::OnConnected userId="+userId+", jsonParams="+jsonParams);
	}
	
	public void OnJoined(String userId, int channelId)
	{
		System.out.println("PTTPlugin2Sample::OnJoined userId="+userId+", channelId="+channelId);
	}
	
	public void OnLocked(String userId, int channelId, int lockIndex, int mediaProfileId, String userLocation, String audioCodec, String videoCodec, String encKey, String jsonParams)
	{
		System.out.println("PTTPlugin2Sample::OnLocked userId="+userId+", channelId="+channelId+", jsonParams="+jsonParams);
	}

	public void OnPTT(int channelId, int lockIndex, byte[] frames)
	{
		System.out.println("PTTPlugin2Sample::OnPTT channelId="+channelId+", frames.length="+frames.length);
	}

	public void OnUnLocked(String userId, int channelId, int lockIndex)
	{
		System.out.println("PTTPlugin2Sample::OnUnlocked userId="+userId+", channelId="+channelId);
	}
	
	public void OnVideoShared(String userId, int channelId, int videoChannelId, String jsonParams)
	{
		System.out.println("PTTPlugin2Sample::OnVideoShared userId="+userId+", channelId="+channelId+", videoChannelId="+videoChannelId+", jsonParams="+jsonParams);
	}
	
	public void OnUnVideoShared(String userId, int channelId, int videoChannelId)
	{
		System.out.println("PTTPlugin2Sample::OnUnVideoShared userId="+userId+", channelId="+channelId+", videoChannelId="+videoChannelId);
	}
	
	public void OnText(String userId, int channelId, int messageId, String base64Message)
	{
		System.out.println("PTTPlugin2Sample::OnText userId="+userId+", channelId="+channelId+", messageId="+messageId+", base64Message="+base64Message);
	}
	
	public void OnCustomMessage(String userId, int channelId, int messageId, String base64Message)
	{
		System.out.println("PTTPlugin2Sample::OnCustomMessage userId="+userId+", channelId="+channelId+", messageId="+messageId+", base64Message="+base64Message);
	}
	
	public void OnFunction(String userId, int channelId, String latitude, String longitude, String functionName, String jsonParams)
	{
		System.out.println("PTTPlugin2Sample::OnFunction userId="+userId+", channelId="+channelId+", functionName="+functionName+", jsonParams="+jsonParams);
	}
	
	public void OnLocation(String userId, String latitude, String longitude)
	{
		System.out.println("PTTPlugin2Sample::OnLocation userId="+userId+", latitude="+latitude+", longitude="+longitude);
	}
	
	public void OnLeaved(String userId, int channelId)
	{
		System.out.println("PTTPlugin2Sample::OnLeaved userId="+userId+", channelId="+channelId);
	}
	
	public void OnDisconnected(String userId)
	{
		System.out.println("PTTPlugin2Sample::OnDisconnected userId="+userId);
	}

	public void OnError(int errCode, String jsonParams)
	{
		System.out.println("PTTPlugin2Sample::OnError errCode="+errCode+", jsonParams="+jsonParams);
	}
	
	public void OnExtenedEvent(String cmdName, String jsonParams)
	{
		System.out.println("PTTPlugin2Sample::OnExtenedEvent cmdName="+cmdName+", jsonParams="+jsonParams);
	}
	
}
